/* Header for module math, generated by p2c */
#ifndef MATH_H
#define MATH_H


#ifdef MATH_G
# define vextern
#else
# define vextern extern
#endif
/* p2c: math.pas, line 6: 
 * Note: Turbo Pascal conditional compilation directive was ignored [218] */


/*$IFDEF DOUBLE_PRECISION*/
/*$ELSE*/
/* p2c: math.pas, line 9:
 * Note: Turbo Pascal conditional compilation directive was ignored [218] */
/*$IFDEF SINGLE_PRECISION*/
/* p2c: math.pas, line 10:
 * Warning: Symbol 'FLOAT' was already defined [220] */
/*$ELSE*/
/* p2c: math.pas, line 12:
 * Warning: Symbol 'FLOAT' was already defined [220] */
/*$ENDIF*/
/*$ENDIF*/

typedef union vector {
  struct {
    double i, j, k;
  } U1;
  double a[3];
} vector;

typedef struct state_vector {
  vector r, v;
} state_vector;

typedef union dir_cosines {
  struct {
    vector row1, row2, row3;
  } U1;
  double m[3][3];
} dir_cosines;


extern void vector_init (double i, double j, double k, vector *result);

extern boolean vector_null_check (vector *v);

extern boolean vector_equal_check (vector *v1, vector *v2);

extern void vector_negate (vector *v, vector *result);

extern double vector_mag (vector *v);

extern void vector_unit (vector *v, vector *result);

extern void vector_cross (vector *v1, vector *v2, vector *result);

extern double vector_dot (vector *v1, vector *v2);

extern void vector_add (vector *v1, vector *v2, vector *result);

extern void vector_subtract (vector *v1, vector *v2, vector *result);

extern void dir_cosines_init (vector *v1, vector *v2, vector *v3,
				 dir_cosines *dc);

extern void dir_cosines_invert (dir_cosines *dc, dir_cosines *result);

extern void dir_cosines_calc (vector *ivec, vector *up, dir_cosines *dc);

extern void coordinate_transformation (vector *v, dir_cosines *dc,
					  vector *result);

extern double modulo (double x, double y);

extern double pos_modulo (double x, double y);

extern double power (double x, double y);

extern double tan_ (double x);

extern double arcsin_ (double x);

extern double arccos_ (double x);

extern double arctan2 (double sinx, double cosx);

extern double sign (double a);

extern double bounds (double low, double value, double high);

extern long ibounds (long low, long value, long high);
/* AHA: max => Max */
extern double Max (double v1, double v2);
/* AHA: min => Min */
extern double Min (double v1, double v2);

extern long imax (long v1, long v2);

extern long imin (long v1, long v2);


extern void swap_ (double *a, double *b);


#undef vextern

#endif /*MATH_H*/

/* End. */
